<?php
/*
 * Plugin Name:   cbnet MBP Auto-Activate
 * Plugin URI:    http://www.chipbennett.net/wordpress/plugins/cbnet-mbp-auto-activate/
 * Description:   Automatically activate MaxBlogPress plugins, without registering and without subscribing to the MaxBlogPress email list.
 * Version:       1.1
 * Author:        Chip Bennett
 * Author URI:    http://www.chipbennett.net/
 *
 * License:       GNU General Public License, v2 (or newer)
 * License URI:  http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * Thanks to andreasnrb for his assistance (and patience)
 * with this plugin. And thanks also to all the other fine folks at  the
 * WPTavern Forum (http://www.wptavern.com/forum) for their help.
 */
 
define('cbnetmbpauto_NAME', 'cbnet MBP Auto-Activate');	// Name of the Plugin
define('cbnetmbpauto_VERSION', '1.1');				// Current version of the Plugin

/**
 * cbnetMBPauto - cbnet MBP Auto-Activate Class
 * Holds all the necessary functions and variables
 */
class cbnetmbpauto 
{
	/**
	 * Constructor. Adds cbnet MBP Auto-Update plugin's actions/filters.
	 * @access public
	 */
	function cbnetmbpauto() { 
	
		// Define an array containing the prefixes for all MaxBlogPress plugins:
		$this->cbnetmbpautoPrefixes = array( 'dppp', 'mdw', 'mup', 'mpo', 'msa', 'ps', 'mfi', 'spl', 'mba', 'dpc', 'mcn', 'ofa', 'facp', 'adr', 'ffr', 'mbp_lmw', 'mbp_ba', 'mbp_apl', 'mbpri', 'abc', 'captcha', 'mbp_alt', 'mbp_io', 'rc', 'mbp_po', 'mbp_pi', 'mbp_plbc', 'mbp_el' );
		
		// Define arrays for each plugin, with the following values: name, prefix, installed state
		$this->cbnetmbpauto_dppp = array( 'plugin' => 'different-posts-per-page', 'pluginname' => 'Different Posts Per Page', 'prefix' => 'dppp', 'installed' => 'false' );
		$this->cbnetmbpauto_mdw = array( 'plugin' => 'dealdotcom-widget-54', 'pluginname' => 'DealDotCom Widget', 'prefix' => 'mdw', 'installed' => 'false' );
		$this->cbnetmbpauto_mup = array( 'plugin' => 'maxblogpress-unblockable-popup', 'pluginname' => 'Unblockable Popup', 'prefix' => 'mup', 'installed' => 'false' );
		$this->cbnetmbpauto_mpo = array( 'plugin' => 'maxblogpress-ping-optimizer', 'pluginname' => 'Ping Optimizer', 'prefix' => 'mpo', 'installed' => 'false' );
		$this->cbnetmbpauto_msa = array( 'plugin' => 'maxblogpress-stripe-ad', 'pluginname' => 'Stripe Ad', 'prefix' => 'msa', 'installed' => 'false' );
		$this->cbnetmbpauto_ps = array( 'plugin' => 'psychic-search', 'pluginname' => 'Psychic Search', 'prefix' => 'ps', 'installed' => 'false' );
		$this->cbnetmbpauto_mfi = array( 'plugin' => 'maxblogpress-favicon', 'pluginname' => 'Favicon', 'prefix' => 'mfi', 'installed' => 'false' );
		$this->cbnetmbpauto_spl = array( 'plugin' => 'seo-post-link', 'pluginname' => 'SEO Post Link', 'prefix' => 'spl', 'installed' => 'false' );
		$this->cbnetmbpauto_mba = array( 'plugin' => 'max-banner-ads', 'pluginname' => 'Banner Ads', 'prefix' => 'mba', 'installed' => 'false' );
		$this->cbnetmbpauto_dpc = array( 'plugin' => 'duplicate-post-checker', 'pluginname' => 'Duplicate Post Checker', 'prefix' => 'dpc', 'installed' => 'false' );
		$this->cbnetmbpauto_mcn = array( 'plugin' => 'multi-author-comment-notification', 'pluginname' => 'Multi Author Comment Notification', 'prefix' => 'mcn', 'installed' => 'false' );
		$this->cbnetmbpauto_ofa = array( 'plugin' => 'maxblogpress-optin-form-adder', 'pluginname' => 'Optin Form Adder', 'prefix' => 'ofa', 'installed' => 'false' );
		$this->cbnetmbpauto_fbpc = array( 'plugin' => 'front-page-by-category', 'pluginname' => 'Front Page By Category', 'prefix' => 'fpbc', 'installed' => 'false' );
		$this->cbnetmbpauto_adr = array( 'plugin' => 'adsense-deluxe-revisited', 'pluginname' => 'AdSense Deluxe Revisited', 'prefix' => 'adr', 'installed' => 'false' );
		$this->cbnetmbpauto_ffr = array( 'plugin' => 'flash-fader-revived', 'pluginname' => 'Flash Fader Revived', 'prefix' => 'ffr', 'installed' => 'false' );
		$this->cbnetmbpauto_mbp_lmw = array( 'plugin' => 'links-manage-widget', 'pluginname' => 'Links Manage Widget', 'prefix' => 'mbp_lmw', 'installed' => 'false' );
		$this->cbnetmbpauto_mbp_ba = array( 'plugin' => 'banner-ads', 'pluginname' => 'Banner Ads', 'prefix' => 'mbp_ba', 'installed' => 'false' );
		$this->cbnetmbpauto_mbp_apl = array( 'plugin' => 'ajax-post-listing', 'pluginname' => 'Ajax Post Listing', 'prefix' => 'mbp_apl', 'installed' => 'false' );
		$this->cbnetmbpauto_mbpri = array( 'plugin' => 'random-image', 'pluginname' => 'Random Image', 'prefix' => 'mbpri', 'installed' => 'false' );
		$this->cbnetmbpauto_abc = array( 'plugin' => 'access-by-category', 'pluginname' => 'Access By Category', 'prefix' => 'abc', 'installed' => 'false' );
		$this->cbnetmbpauto_captcha = array( 'plugin' => 'captcha-for-comment', 'pluginname' => 'Captcha For Comment', 'prefix' => 'captcha', 'installed' => 'false' );
		$this->cbnetmbpauto_mbp_alt = array( 'plugin' => 'affiliate-image-tracker', 'pluginname' => 'Affiliate Image Tracker', 'prefix' => 'mbp_alt', 'installed' => 'false' );
		$this->cbnetmbpauto_mbp_io = array( 'plugin' => 'image-organizer', 'pluginname' => 'Image Organizer', 'prefix' => 'mbo_io', 'installed' => 'false' );
		$this->cbnetmbpauto_rc = array( 'plugin' => 'easy-custom-fields', 'pluginname' => 'Easy Custom Fields', 'prefix' => 'rc', 'installed' => 'false' );
		$this->cbnetmbpauto_mbp_po = array( 'plugin' => 'post-ordering', 'pluginname' => 'Post Ordering', 'prefix' => 'mbp_po', 'installed' => 'false' );
		$this->cbnetmbpauto_mbp_pi = array( 'plugin' => 'post-image', 'pluginname' => 'Post Image', 'prefix' => 'mbp_pi', 'installed' => 'false' );
		$this->cbnetmbpauto_mbp_plbc = array( 'plugin' => 'posts-list-by-category', 'pluginname' => 'Posts List By Category', 'prefix' => 'mbp_plbc', 'installed' => 'false' );
		$this->cbnetmbpauto_mbp_el = array( 'plugin' => 'excerpt-listing', 'pluginname' => 'Excerpt Listing', 'prefix' => 'mbp_el', 'installed' => 'false' );
		
		// Hooks - codex: http://codex.wordpress.org/Plugin_API
	    add_action('activate_'.$this->cbnetmbpauto_path, array(&$this, 'cbnetmbpautoActivate'));
		add_action('admin_init', array(&$this, 'cbnetmbpautoUpdateOptions')); 
		add_action('admin_menu', array(&$this, 'cbnetmbpautoAddMenu')); 
		add_action('admin_head', array(&$this, 'cbnetmbpauto_css'));
	}
	
	/**
	 * Called when plugin is activated and when an Admin page is loaded. Adds option value to the options table.
	 */
	function cbnetmbpautoActivate() {
		cbnetmbpautoUpdateOptions();
		return true;
	}
	
	/**
	 * Updates xyz_activate option for installed MBP plugins
	 */
	function cbnetmbpautoUpdateOptions() {
		// pull in the array of prefixes from the Constructor
		$prefixes = $this->{'cbnetmbpauto_'.$prefix}['prefix']; // $prefixes = $this->cbnetmbpautoPrefixes;
		// check for each plugin
		foreach($prefixes as $prefix) {  
           // sets $key to 'xyz_activate' - which is the variable each plugin uses
		   $key=$prefix.'_activate';  
			// set 'xyz_activate' value to '2' ("activated")
			update_option( $key, '2'); 
		}
	}
	
	/**
	 * Adds "cbnet MBP Auto-Update" link to admin Options menu
	 */
	function cbnetmbpautoAddMenu() {
		// codex: http://codex.wordpress.org/Adding_Administration_Menus
		add_options_page('cbnet MBP Auto-Update', 'cbnet MBP Auto-Update', 'manage_options', 'cbnet-mbp-auto-activate', array(&$this, 'cbnetmbpautoOptionsPg'));
		// old: add_options_page('cbnet MBP Auto-Update', 'cbnet MBP Auto-Update', 'manage_options', array(&$this, 'cbnetmbpautoOptionsPg'));
	}
	
	/**
	 * Displays the page content for "cbnet MBP Auto-Update" Options submenu
	 * Carries out all the operations in Options page
	 */
	function cbnetmbpautoOptionsPg() {
			// codex: http://codex.wordpress.org/Creating_Options_Pages
			?>
			
			<div class="wrap">
			 <h2><?php echo cbnetmbpauto_NAME; ?></h2>
			
			<h3>MaxBlogPress Plugins - Status</h3>
			<table id="cbnetmbpauto">
			<tr>
				<th style="width:400px;">Plugin Name</th>
				<th style="width:150px;">Install State</th>
				<th style="width:200px;">MBP Activation State</th>
			</tr>
			<?php
				// pull in the array of prefixes from the Constructor
				$prefixes = $this->{'cbnetmbpauto_'.$prefix}['prefix']; // $prefixes = $this->cbnetmbpautoPrefixes;
				// check for each plugin
				foreach($prefixes as $prefix) { 
					//  return value for cbnetmbpauto_xyz['pluginname'] (plugin name)
					$pluginname = $this->{'cbnetmbpauto_'.$prefix}['pluginname']; 
					// is plugin installed?
					$pluginslug = $this->{'cbnetmbpauto_'.$prefix}['plugin'];
					$pluginpath = $pluginslug.'/'.$pluginslug.'.php';
					$pluginactive = is_plugin_active( $pluginpath);
					// if plugin is installed, set the installed state to "true" in plugin array
					$this->{'cbnetmbpauto_'.$prefix}['installed'] =  ( $pluginactive ? 'true' : 'false'); 
					//  return value for cbnetmbpauto_xyz['installed'] (installed state) - "true" or "false"
					$installed = $this->{'cbnetmbpauto_'.$prefix}['installed']; 
					// if $installed = true, 'Installed', else 'Not Installed'
					$installedtxt = ( $installed == 'true' ? 'Installed' : 'Not Installed' ); 
					// set $key to 'xyz_activate' - which is the variable each plugin uses
					$key = $prefix.'_activate';
					// return value for 'xyz_activate; - '2' = activated, 'false' = not installed
					$keyval = get_option($key);
					$value = ($keyval ? $keyval : 'null');
					// if $value = false, 'N/A', else 'Activated'
					$state = ($installed == 'true' ? 'Activated' : 'N/A'); 
					$emphasis = ( $installed  == 'true' ? ' class="cbnetmbpautoinstalled"' : '');
					?>
						<tr>
							<td<?php echo $emphasis; ?> style="text-align:left;">MaxBlogPress <?php echo $pluginname; ?> plugin</td>
							<td<?php echo $emphasis; ?>><?php echo $installedtxt; ?></td>
							<td<?php echo $emphasis; ?>><?php echo $state; ?></td>
						</tr>
						<?php }
				?>
				</table>
			
			 <p style="text-align:center;margin-top:3em;font-weight:bold;">
				<?php echo cbnetmbpauto_NAME.' '.cbnetmbpauto_VERSION; ?>  by <a href="http://www.chipbennett.net/" target="_blank" >Chip Bennett</a>
			 </p>
			</div>
			<?php
		}
	
	function cbnetmbpauto_css() {
		
		echo "
		<style type='text/css'>
		.wrap #cbnetmbpauto {
			padding:0;
			margin:0;
			text-align:center;
			border:1px solid black;
			border-collapse: collapse;
			font-size:8pt;
		}
		.wrap #cbnetmbpauto tr {
			padding:0;
			margin:0;
			text-align:center;
		}
		.wrap #cbnetmbpauto th {
			font-weight:bold;
			background-color:silver;
			text-align:center;
			border-bottom:1px solid black;
		}
		.wrap #cbnetmbpauto td {
			padding:3px;
			margin:0;
			border-bottom:1px solid silver;
			border-spacing:0;
			text-align:center;
			font-size:7pt;
		}
		.wrap #cbnetmbpauto td.cbnetmbpautoinstalled {
			font-weight: bold;
			color: blue;
			background-color: #ddd;
		}
		</style>
		";
	}
	
} // Eof Class

$cbnetmbpauto = new cbnetmbpauto();
?>